﻿//-----------------------------------------------------------------------------
//    This file is part of ds30 Loader GUI.
//
//    ds30 Loader GUI is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    ds30 Loader GUI is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with ds30 Loader GUI.  If not, see <http://www.gnu.org/licenses/>.
//----------------------------------------------------------------------------- 

using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;
using System.Xml;
using System.Xml.Serialization;

namespace ds30_Loader_GUI
{
    //---------------------------------------------------------------------------
    // Class: clsLatestVersionInfo
    //---------------------------------------------------------------------------
    public class clsLatestVersionInfo
    {

		//---------------------------------------------------------------------
		// Property: allowUpdate
        //---------------------------------------------------------------------
        public bool allowUpdate { get; set; }


		//---------------------------------------------------------------------
		// Property: allowDownload
        //---------------------------------------------------------------------
        public bool allowDownload { get; set; }


		//---------------------------------------------------------------------
		// Property: verds30Loader
        //---------------------------------------------------------------------
        public Version verds30Loader { get; set; }


		//---------------------------------------------------------------------
		// Property: verds30LoaderGUI
        //---------------------------------------------------------------------
        public Version verds30LoaderGUI { get; set; }


		//---------------------------------------------------------------------
		// Property: urlLatestPackage
        //---------------------------------------------------------------------
        public string urlLatestPackage { get; set; }


		//---------------------------------------------------------------------
		// Property: urlds30Loader_dll
        //---------------------------------------------------------------------
        public string urlds30Loader_dll { get; set; }


		//---------------------------------------------------------------------
		// Property: urlds30LoaderGUI_exe
        //---------------------------------------------------------------------
        public string urlds30LoaderGUI_exe { get; set; }
        

		//---------------------------------------------------------------------
		// Property: latestVersionInfo
        //---------------------------------------------------------------------
        public string latestVersionInfo { get; set; }


		//---------------------------------------------------------------------
		// CheckLatestVersion()
		// Description:
		//---------------------------------------------------------------------
		public bool CheckLatestVersion()		
        {
            try  
                {  
                string xmlURL = frmDS30Loader.strURLHomepage + "data/latestversions_v1.xml";  
                XmlTextReader reader = new XmlTextReader(xmlURL);  

                // skip the junk at the beginning  
                reader.MoveToContent();  
                
                string elementName = "";                  
                
                if ( reader.NodeType == XmlNodeType.Element && reader.Name == "gui" )  {  
                    while ( reader.Read() ) { 
                        if ( reader.NodeType == XmlNodeType.Element ) {
                            elementName = reader.Name;  
                        } else {  
                            if ( reader.NodeType == XmlNodeType.Text && reader.HasValue ) { 
                                switch ( elementName ) {  
                                    case "versionds30Loader":  
                                        verds30Loader = new Version(reader.Value); 
                                        break;  
                                     case "versionds30LoaderGUI":  
                                        verds30LoaderGUI = new Version(reader.Value); 
                                        break;  
                                    case "urlPackage":  
                                        urlLatestPackage = reader.Value;  
                                        break;  
                                    case "allowUpdate":
                                        allowUpdate = bool.Parse( reader.Value );
                                        break;
                                    case "allowPackageDownload":
                                        allowDownload = bool.Parse( reader.Value );
                                        break;
                                    case "info":
                                        latestVersionInfo = reader.Value;
                                        break;
                                    case "urlds30Loder_dll":
                                        urlds30Loader_dll = reader.Value;
                                        break;
                                    case "urlds30LoderGUI_exe":
                                        urlds30LoaderGUI_exe = reader.Value;
                                        break;
                                }  
                            }  
                        }  
                    }  
                }  
                reader.Close();  
            } catch ( Exception e ) {  
                latestVersionInfo = "Failed to retrieve latest version information: " + e.Message;
                return false;
            }

            return true;
        }// CheckLatestVersion()

    }// Class: clsLatestVersionInfo
}
