﻿//-----------------------------------------------------------------------------
//    This file is part of ds30 Loader GUI.
//
//    ds30 Loader GUI is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    ds30 Loader GUI is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with ds30 Loader GUI.  If not, see <http://www.gnu.org/licenses/>.
//----------------------------------------------------------------------------- 

using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;
using System.Xml;
using System.Xml.Serialization;

namespace ds30_Loader_GUI
{
    //---------------------------------------------------------------------------
    // Class: settings
    //---------------------------------------------------------------------------
    [XmlRoot("ds30LoaderSettings")]
    public class clsSettings
    {
		//---------------------------------------------------------------------
		// Constructor
        //---------------------------------------------------------------------
        public clsSettings() 
        {
	        DefaultStartSettings = new clsDefaultStartSettings();

            CheckVerStart = false;
            WindowOnTop = false;
            WindowWidth = 343;
		    WindowHeight = 457;
            Filename = string.Empty;
        }// Constructor

        
		//---------------------------------------------------------------------
		// Options
        //---------------------------------------------------------------------
        public bool CheckVerStart { get; set; }


		//---------------------------------------------------------------------
		// View options
        //---------------------------------------------------------------------
        public bool WindowOnTop { get; set; }


		//---------------------------------------------------------------------
		// Window size
        //---------------------------------------------------------------------
        public int WindowWidth { get; set; }
        public int WindowHeight { get; set; }


		//---------------------------------------------------------------------
		// Basic tab
        //---------------------------------------------------------------------
		public string Filename { get; set; }


		//---------------------------------------------------------------------
		// Distribution Specific
		//---------------------------------------------------------------------
    	public clsDefaultStartSettings DefaultStartSettings { get; set;}
    }// Class: settings
}
